/*
 * Copyright
 *   2007 axYus - www.axyus.com
 *
 * This file is part of XEMELIOS.
 *
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package fr.gouv.finances.dgfip.xemelios.web.gwt.client.widget.search.criteria;

import fr.gouv.finances.dgfip.xemelios.web.gwt.client.dto.InputCritereItemDTO;

/**
 * @author CBO
 * Classe de base de tous les composants affichés dans une ligne de critère qui ont une valeur
 */
abstract public class InputCritereWidget extends CritereWidget {

    private InputCritereItemDTO inputCritereItem;

    public String getInputId() {
        return inputCritereItem.getInputId();
    }

    public InputCritereWidget(CritereLineContainer critereLineContainer, InputCritereItemDTO inputCritereItem) {
        super(critereLineContainer);
        this.inputCritereItem = inputCritereItem;
    }

    public boolean isFilled() {
        return getInputValue() != null && !getInputValue().trim().equals("");
    }

    abstract public void setFocus();

    abstract public void refresh();

    abstract public void checkValidity() throws ValidityException;

    abstract public String getInputValue();

    static public class ValidityException extends Exception {
        
        private String messageToDisplay;
        
        public ValidityException(String messageToDisplay) {
            this.messageToDisplay = messageToDisplay;
        }
        
        public String getMessageToDisplay() {
            return this.messageToDisplay;
        }
        
    }
    
}
